#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>

#include <share.h>
#include <io.h>
#include <conio.h>

#if !defined(__OS2__)
#include <alloc.h>
#endif

#include "busy.h"

void makeHeaderCRC();

int doConvert( void )
{
  loadHystory( hystNameOld );
  fclose( hystFile );

  memset( &hystHeader, 0, sizeof(hystHeader) );
/*
  hystHeader.date           = hystHeaderOld.date          ;
  hystHeader.init           = hystHeaderOld.init          ;
  hystHeader.lines          = hystHeaderOld.lines         ;
  hystHeader.size           = hystHeaderOld.size          ;
  hystHeader.inSessions     = hystHeaderOld.inSessions    ;
  hystHeader.outSessions    = hystHeaderOld.outSessions   ;
  hystHeader.inHand         = hystHeaderOld.inHand        ;
  hystHeader.outHand        = hystHeaderOld.outHand       ;
  hystHeader.totalDialing   = hystHeaderOld.totalDialing  ;
  hystHeader.totalAnswering = hystHeaderOld.totalAnswering;
  hystHeader.totalIncome    = hystHeaderOld.totalIncome   ;
  hystHeader.totalOutcome   = hystHeaderOld.totalOutcome  ;
  hystHeader.totalExternal  = hystHeaderOld.totalExternal ;
  hystHeader.totalBytesIn   = hystHeaderOld.totalBytesIn  ;
  hystHeader.totalBytesOut  = hystHeaderOld.totalBytesOut ;
  hystHeader.totalBBS       = hystHeaderOld.totalBBS      ;
  hystHeader.totalTerminal  = hystHeaderOld.totalTerminal ;
  hystHeader.inMail         = hystHeaderOld.inMail        ;
  hystHeader.inXmail        = hystHeaderOld.inXmail       ;
  hystHeader.inFiles        = hystHeaderOld.inFiles       ;
  hystHeader.outMail        = hystHeaderOld.outMail       ;
  hystHeader.outXmail       = hystHeaderOld.outXmail      ;
  hystHeader.outFiles       = hystHeaderOld.outFiles      ;
  hystHeader.sesFTS0001     = hystHeaderOld.sesFTS0001    ;
  hystHeader.sesWaZOO       = hystHeaderOld.sesWaZOO      ;
  hystHeader.sesEMSI        = hystHeaderOld.sesEMSI       ;
*/
  memcpy( &hystHeader.date, &hystHeaderOld.date, sizeof( big ) * 26 );

  memcpy( &hystHeader.sign, hystHeaderSign, sizeof(hystHeaderSign) - 1 );
  memcpy( &hystHeader.hLogStart, hystHeaderOld.hLogStart, sizeof(logStart) );
  memcpy( &hystHeader.hLogEnd, hystHeaderOld.hLogEnd, sizeof(logEnd) );

  memcpy( info, hystInfo, sizeof(info) );
  nodesInfo = hystNodes;
  ioInfo = hystIoInfo;
  totalNodes = hystTotalNodes;
  totalIO = hystTotalIO;
  memcpy( logStart, hystHeader.hLogStart, sizeof(logStart) );
  memcpy( logEnd, hystHeader.hLogEnd, sizeof(logEnd) );

  makeHeaderCRC();

  hystFile = fopen( hystName, "w+b" );

  if( hystFile==NULL )
  {
    printf( "Error encountered reading file %s.\n", hystName );
    return 5;
  }

  setbuf( hystFile, NULL );
  storeHystory();

  return 0;
}

int Cdecl main( int argn, char **argc )
{
  puts( progName );

  printf( "hystHeaderSign : %u\nhystHeaderSignOld : %u\n",
      sizeof( hystHeaderSign ), sizeof( hystHeaderSignOld ) );

  printf( "hystHeader.sign : %u\nhystHeaderOld.sign : %u\n",
      sizeof( hystHeader.sign ), sizeof( hystHeaderOld.sign ) );

// return 0;

  if( argn < 2 )
  {
     puts( "\n***** Error: Unsufficient parameters." );
     puts( "Usage: histcvt old_history_file new_history_file" );
     return 1;
  }

  hystNameOld = argc[1];
  hystName = argc[2];

  return doConvert();

}