#=============================================================
#
#	HISTCVT.MAK - Makefile for project E:\Runtime.os2\fido\Vagabondo\HistCvt\histcvt.PRJ
#		Created on 05/23/98 at 04:31
#
#=============================================================

.AUTODEPEND

.PATH.obj = .

#=============================================================
#		Translator Definitions
#=============================================================
CC = bcc +HISTCVT.CFG
TASM = tasm.exe
TLIB = tlib.exe
TLINK = tlink
RC = brcc.exe
RB = rc.exe
LIBPATH = E:\BIN\BC\LIB
INCLUDEPATH = E:\BIN\BC\INCLUDE;.\.;


#=============================================================
#		Implicit Rules
#=============================================================
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

.asm.obj:
  $(TASM) -Mx $*.asm,$*.obj

.rc.res:
  $(RC) -r $*.rc

#=============================================================
#		List Macros
#=============================================================


EXE_DEPENDENCIES =  \
 initdata.obj \
 history.obj \
 histcvt.obj \
 misc.obj

#=============================================================
#		Explicit Rules
#=============================================================
.\histcvt.exe: histcvt.cfg $(EXE_DEPENDENCIES)
  $(TLINK) /s /wdef /wimt /wmsk /wdpl /Toe /ap /L$(LIBPATH) @&&|
E:\BIN\BC\LIB\C02.OBJ+
.\initdata.obj+
.\history.obj+
.\histcvt.obj+
.\misc.obj
.\histcvt,.\histcvt
E:\BIN\BC\LIB\C2.LIB+
E:\BIN\BC\LIB\OS2.LIB

|


#=============================================================
#		Individual File Dependencies
#=============================================================
initdata.obj: histcvt.cfg initdata.cpp 

history.obj: histcvt.cfg history.cpp 

histcvt.obj: histcvt.cfg histcvt.cpp 

misc.obj: histcvt.cfg misc.cpp 

#=============================================================
#		Compiler Configuration File
#=============================================================
histcvt.cfg: histcvt.mak
  copy &&|
-Oi
-Oz
-Ob
-Oe
-Oc
-L$(LIBPATH)
-I$(INCLUDEPATH)
-n.
-vi-
-k-
-O
-Ot
-w
-wnak
-wnod
-wuse
-wucp
-wstv
-wsig
-wdef
-wcln
-wasm
-wamp
-wamb
-wbbf
-wpin
| histcvt.cfg


